<?php

namespace Slovocast\Infrastructure\Database;

use React\Mysql\MysqlClient;

class ConnectionPoolConfig
{
    public function __construct(
        public readonly string $username,
        public readonly string $password,
        public readonly string $database,
        public readonly string $host,
        protected int $port = 3306,
        protected int $poolWaitTimeout = ConnectionPool::DEFAULT_WAIT_TIMEOUT,
        protected int $totalConnections = 10,
    ) { }

    public function getPort(): int
    {
        return $this->port;
    }

    public function getPoolWaitTimeout(): int
    {
        return $this->poolWaitTimeout;
    }

    public function getTotalConnections(): int
    {
        return $this->totalConnections;
    }

    public function getDsn(): string
    {
        return sprintf(
            "%s:%s@%s/%s",
            rawurlencode($this->username),
            rawurlencode($this->password),
            $this->host,
            $this->database
        );
    }
}
